
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef regionMap_ERROR_H
#define regionMap_ERROR_H

#include "h2errorLib.h"
#include "genom/genomError.h"

#define M_regionMap    (5174)

/* -- MODULES ERRORS -------------------------------------------------- */

/* demo errors */
#define S_regionMap_NOT_CONNECTED        H2_ENCODE_ERR(M_regionMap , 1)
#define S_regionMap_BAD_DISPLAY_PARAMS   H2_ENCODE_ERR(M_regionMap , 2)
#define S_regionMap_OPEN_FILE_FAILED     H2_ENCODE_ERR(M_regionMap , 3)
#define S_regionMap_CALIFE_ERROR         H2_ENCODE_ERR(M_regionMap , 4)
#define S_regionMap_NO_CONNECTION_POSSIBLE H2_ENCODE_ERR(M_regionMap , 5)
#define S_regionMap_CAN_NOT_UPDATE_POSTER H2_ENCODE_ERR(M_regionMap , 6)
#define S_regionMap_FUSION_ERROR         H2_ENCODE_ERR(M_regionMap , 7)
#define S_regionMap_IMAGE3D_ERROR        H2_ENCODE_ERR(M_regionMap , 8)
#define S_regionMap_NOT_CONNECTED_TO_3D_DATA H2_ENCODE_ERR(M_regionMap , 9)
#define S_regionMap_CAN_NOT_READ_POSTER  H2_ENCODE_ERR(M_regionMap , 10)
#define S_regionMap_POM_POSTER_NOT_FOUND H2_ENCODE_ERR(M_regionMap , 11)
#define S_regionMap_ERROR_IN_LIBRARY     H2_ENCODE_ERR(M_regionMap , 12)
#define S_regionMap_BAD_PROBABILITY_VALUE H2_ENCODE_ERR(M_regionMap , 13)
#define S_regionMap_NEGATIVE_RADIUS      H2_ENCODE_ERR(M_regionMap , 14)
#define S_regionMap_RMAP_CAN_NOT_SAVE_MAP H2_ENCODE_ERR(M_regionMap , 15)
#define S_regionMap_RMAP_CAN_NOT_OPEN_FILE H2_ENCODE_ERR(M_regionMap , 16)
#define S_regionMap_NO_MAP_STRUCTURE_INITIALIZED H2_ENCODE_ERR(M_regionMap , 17)
#define S_regionMap_CAN_NOT_LOAD_FILE    H2_ENCODE_ERR(M_regionMap , 18)
#define S_regionMap_CAN_NOT_CREATE_IM3D  H2_ENCODE_ERR(M_regionMap , 19)
#define S_regionMap_POSTER_NOT_FOUND     H2_ENCODE_ERR(M_regionMap , 20)
#define S_regionMap_CAN_NOT_CONNECT      H2_ENCODE_ERR(M_regionMap , 21)
#define S_regionMap_CAN_NOT_READ_PROTO_FILE H2_ENCODE_ERR(M_regionMap , 22)
#define S_regionMap_CAN_NOT_OPEN_FILE    H2_ENCODE_ERR(M_regionMap , 23)
#define S_regionMap_CAN_NOT_ALLOCATE_PROTO_STRUCTURE H2_ENCODE_ERR(M_regionMap , 24)
#define S_regionMap_CAN_NOT_ALLOCATE_MAP H2_ENCODE_ERR(M_regionMap , 25)
#define S_regionMap_BAD_INIT_PARAMS      H2_ENCODE_ERR(M_regionMap , 26)


/* std errors */
#define S_regionMap_stdGenoM_ACTIVITY_INTERRUPTED       339141633   /* 5174<<16 | 0x8000 | 100<<8 | 1 */
#define S_regionMap_stdGenoM_TOO_MANY_ACTIVITIES        339141634   /* 5174<<16 | 0x8000 | 100<<8 | 2 */
#define S_regionMap_stdGenoM_ACTIVITY_FAILED            339141635   /* 5174<<16 | 0x8000 | 100<<8 | 3 */
#define S_regionMap_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY 339141636   /* 5174<<16 | 0x8000 | 100<<8 | 4 */
#define S_regionMap_stdGenoM_UNKNOWN_ACTIVITY           339141637   /* 5174<<16 | 0x8000 | 100<<8 | 5 */
#define S_regionMap_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION 339141638   /* 5174<<16 | 0x8000 | 100<<8 | 6 */
#define S_regionMap_stdGenoM_SYSTEM_ERROR               339141639   /* 5174<<16 | 0x8000 | 100<<8 | 7 */
#define S_regionMap_stdGenoM_ACTIVITY_ALREADY_ENDED     339141640   /* 5174<<16 | 0x8000 | 100<<8 | 8 */
#define S_regionMap_stdGenoM_WAIT_INIT_RQST             339141641   /* 5174<<16 | 0x8000 | 100<<8 | 9 */
#define S_regionMap_stdGenoM_CONTROL_CODEL_ERROR        339141642   /* 5174<<16 | 0x8000 | 100<<8 | 10 */
#define S_regionMap_stdGenoM_EXEC_TASK_SUSPENDED        339141643   /* 5174<<16 | 0x8000 | 100<<8 | 11 */
#define S_regionMap_stdGenoM_BAD_BLOCK_TYPE             339141644   /* 5174<<16 | 0x8000 | 100<<8 | 12 */
#define S_regionMap_stdGenoM_BAD_POSTER_TYPE            339141645   /* 5174<<16 | 0x8000 | 100<<8 | 13 */



/* static H2_ERROR[] */
#define REGIONMAP_H2_ERR_MSGS {\
    {"NOT_CONNECTED", 1},\
    {"BAD_DISPLAY_PARAMS", 2},\
    {"OPEN_FILE_FAILED", 3},\
    {"CALIFE_ERROR", 4},\
    {"NO_CONNECTION_POSSIBLE", 5},\
    {"CAN_NOT_UPDATE_POSTER", 6},\
    {"FUSION_ERROR", 7},\
    {"IMAGE3D_ERROR", 8},\
    {"NOT_CONNECTED_TO_3D_DATA", 9},\
    {"CAN_NOT_READ_POSTER", 10},\
    {"POM_POSTER_NOT_FOUND", 11},\
    {"ERROR_IN_LIBRARY", 12},\
    {"BAD_PROBABILITY_VALUE", 13},\
    {"NEGATIVE_RADIUS", 14},\
    {"RMAP_CAN_NOT_SAVE_MAP", 15},\
    {"RMAP_CAN_NOT_OPEN_FILE", 16},\
    {"NO_MAP_STRUCTURE_INITIALIZED", 17},\
    {"CAN_NOT_LOAD_FILE", 18},\
    {"CAN_NOT_CREATE_IM3D", 19},\
    {"POSTER_NOT_FOUND", 20},\
    {"CAN_NOT_CONNECT", 21},\
    {"CAN_NOT_READ_PROTO_FILE", 22},\
    {"CAN_NOT_OPEN_FILE", 23},\
    {"CAN_NOT_ALLOCATE_PROTO_STRUCTURE", 24},\
    {"CAN_NOT_ALLOCATE_MAP", 25},\
    {"BAD_INIT_PARAMS", 26},\
}

#ifdef __cplusplus
extern "C" {
#endif

extern int regionMapRecordH2errMsgs(void);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
