
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef REGIONMAP_PRINT_H
#define REGIONMAP_PRINT_H

#include "genom/printScan.h"

/* Structures definies par d'autres modules */

#include "server/velodynePrint.h"

#include "server/stereopixelPrint.h"

#include "server/pomPrint.h"


#include "regionMapPosterLib.h"

/* Prototypes */
#ifdef __cplusplus
extern "C" {
#endif
extern void print_struct_REGIONMAP_LIGHTRMAP_POSTER_STR ( FILE *out,
     struct REGIONMAP_LIGHTRMAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_REGIONMAP_STR ( FILE *out,
     struct REGIONMAP_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_rmapDisplayParams ( FILE *out,
     struct rmapDisplayParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_rmapSaveParams ( FILE *out,
     struct rmapSaveParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_rmapLoadPgmParams ( FILE *out,
     struct rmapLoadPgmParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_rmapLoadParams ( FILE *out,
     struct rmapLoadParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_rmapRadiusParams ( FILE *out,
     struct rmapRadiusParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_rmapCircleParams ( FILE *out,
     struct rmapCircleParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_rmapConnectionParams ( FILE *out,
     struct rmapConnectionParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_enum_rmapConnection ( FILE *out,
     enum rmapConnection *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_rmapInitParams ( FILE *out,
     struct rmapInitParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_enum_rmapFusionType ( FILE *out,
     enum rmapFusionType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_enum_rmapBoolean ( FILE *out,
     enum rmapBoolean *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_rmapLightMap ( FILE *out,
     struct rmapLightMap *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_rmapMap ( FILE *out,
     struct rmapMap *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_struct_rmapCell ( FILE *out,
     struct rmapCell *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_enum_RMAP_PROBAS ( FILE *out,
     enum RMAP_PROBAS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_enum_RMAP_CELL_STATUS ( FILE *out,
     enum RMAP_CELL_STATUS *x,
     int indent, int nDim, int *dims, FILE *in );

/* ======================== PRINT DES TYPEDEF ============================= */

extern void print_RMAP_CELL_STATUS ( FILE *out,
     RMAP_CELL_STATUS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_RMAP_PROBAS ( FILE *out,
     RMAP_PROBAS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_rmapCell ( FILE *out,
     rmapCell *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_rmapMap ( FILE *out,
     rmapMap *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_rmapLightMap ( FILE *out,
     rmapLightMap *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_rmapBoolean ( FILE *out,
     rmapBoolean *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_rmapFusionType ( FILE *out,
     rmapFusionType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_rmapInitParams ( FILE *out,
     rmapInitParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_rmapConnection ( FILE *out,
     rmapConnection *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_rmapConnectionParams ( FILE *out,
     rmapConnectionParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_rmapCircleParams ( FILE *out,
     rmapCircleParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_rmapRadiusParams ( FILE *out,
     rmapRadiusParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_rmapLoadParams ( FILE *out,
     rmapLoadParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_rmapLoadPgmParams ( FILE *out,
     rmapLoadPgmParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_rmapSaveParams ( FILE *out,
     rmapSaveParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_rmapDisplayParams ( FILE *out,
     rmapDisplayParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_REGIONMAP_STR ( FILE *out,
     REGIONMAP_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void print_REGIONMAP_LIGHTRMAP_POSTER_STR ( FILE *out,
     REGIONMAP_LIGHTRMAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
#ifdef __cplusplus
}
#endif

#endif /* REGIONMAP_PRINT_H */

