
/* 
 * Copyright (c) 2003 LAAS/CNRS
 * Sara Fleury
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef REGIONMAP_PRINTXML_H
#define REGIONMAP_PRINTXML_H

#include "genom/printScan.h"
#include "genom/printXMLProto.h"

/* Structures definies par d'autres modules */

#include "server/velodynePrintXML.h"

#include "server/stereopixelPrintXML.h"

#include "server/pomPrintXML.h"


#include "regionMapPosterLib.h"

/* Prototypes */
extern void printXML_struct_REGIONMAP_LIGHTRMAP_POSTER_STR ( FILE *out, char *name,
     struct REGIONMAP_LIGHTRMAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_REGIONMAP_STR ( FILE *out, char *name,
     struct REGIONMAP_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_rmapDisplayParams ( FILE *out, char *name,
     struct rmapDisplayParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_rmapSaveParams ( FILE *out, char *name,
     struct rmapSaveParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_rmapLoadPgmParams ( FILE *out, char *name,
     struct rmapLoadPgmParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_rmapLoadParams ( FILE *out, char *name,
     struct rmapLoadParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_rmapRadiusParams ( FILE *out, char *name,
     struct rmapRadiusParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_rmapCircleParams ( FILE *out, char *name,
     struct rmapCircleParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_rmapConnectionParams ( FILE *out, char *name,
     struct rmapConnectionParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_rmapConnection ( FILE *out, char *name,
     enum rmapConnection *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_rmapInitParams ( FILE *out, char *name,
     struct rmapInitParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_rmapFusionType ( FILE *out, char *name,
     enum rmapFusionType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_rmapBoolean ( FILE *out, char *name,
     enum rmapBoolean *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_rmapLightMap ( FILE *out, char *name,
     struct rmapLightMap *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_rmapMap ( FILE *out, char *name,
     struct rmapMap *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_struct_rmapCell ( FILE *out, char *name,
     struct rmapCell *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_RMAP_PROBAS ( FILE *out, char *name,
     enum RMAP_PROBAS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_enum_RMAP_CELL_STATUS ( FILE *out, char *name,
     enum RMAP_CELL_STATUS *x,
     int indent, int nDim, int *dims, FILE *in );

/* ======================== PRINT DES TYPEDEF ============================= */

extern void printXML_RMAP_CELL_STATUS ( FILE *out, char *name,
     RMAP_CELL_STATUS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_RMAP_PROBAS ( FILE *out, char *name,
     RMAP_PROBAS *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_rmapCell ( FILE *out, char *name,
     rmapCell *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_rmapMap ( FILE *out, char *name,
     rmapMap *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_rmapLightMap ( FILE *out, char *name,
     rmapLightMap *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_rmapBoolean ( FILE *out, char *name,
     rmapBoolean *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_rmapFusionType ( FILE *out, char *name,
     rmapFusionType *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_rmapInitParams ( FILE *out, char *name,
     rmapInitParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_rmapConnection ( FILE *out, char *name,
     rmapConnection *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_rmapConnectionParams ( FILE *out, char *name,
     rmapConnectionParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_rmapCircleParams ( FILE *out, char *name,
     rmapCircleParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_rmapRadiusParams ( FILE *out, char *name,
     rmapRadiusParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_rmapLoadParams ( FILE *out, char *name,
     rmapLoadParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_rmapLoadPgmParams ( FILE *out, char *name,
     rmapLoadPgmParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_rmapSaveParams ( FILE *out, char *name,
     rmapSaveParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_rmapDisplayParams ( FILE *out, char *name,
     rmapDisplayParams *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_REGIONMAP_STR ( FILE *out, char *name,
     REGIONMAP_STR *x,
     int indent, int nDim, int *dims, FILE *in );
extern void printXML_REGIONMAP_LIGHTRMAP_POSTER_STR ( FILE *out, char *name,
     REGIONMAP_LIGHTRMAP_POSTER_STR *x,
     int indent, int nDim, int *dims, FILE *in );

#endif /* REGIONMAP_PRINT_XML_H */

