
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef REGIONMAP_SCAN_H
#define REGIONMAP_SCAN_H


/* Structures definies par d'autres modules */

#include "server/tclservClient/velodyneTclservClientDecode.h"

#include "server/tclservClient/stereopixelTclservClientDecode.h"

#include "server/tclservClient/pomTclservClientDecode.h"


/* Structures du module */
#include "server/regionMapPosterLib.h"

/* Prototypes */
#ifdef __cplusplus
extern "C" {
#endif
int scan_buf_struct_REGIONMAP_LIGHTRMAP_POSTER_STR (char** buf, struct REGIONMAP_LIGHTRMAP_POSTER_STR *x, int nDim, int *dims );
int scan_buf_struct_REGIONMAP_STR (char** buf, struct REGIONMAP_STR *x, int nDim, int *dims );
int scan_buf_struct_rmapDisplayParams (char** buf, struct rmapDisplayParams *x, int nDim, int *dims );
int scan_buf_struct_rmapSaveParams (char** buf, struct rmapSaveParams *x, int nDim, int *dims );
int scan_buf_struct_rmapLoadPgmParams (char** buf, struct rmapLoadPgmParams *x, int nDim, int *dims );
int scan_buf_struct_rmapLoadParams (char** buf, struct rmapLoadParams *x, int nDim, int *dims );
int scan_buf_struct_rmapRadiusParams (char** buf, struct rmapRadiusParams *x, int nDim, int *dims );
int scan_buf_struct_rmapCircleParams (char** buf, struct rmapCircleParams *x, int nDim, int *dims );
int scan_buf_struct_rmapConnectionParams (char** buf, struct rmapConnectionParams *x, int nDim, int *dims );
int scan_buf_enum_rmapConnection (char** buf, enum rmapConnection *x, int nDim, int *dims );
int scan_buf_struct_rmapInitParams (char** buf, struct rmapInitParams *x, int nDim, int *dims );
int scan_buf_enum_rmapFusionType (char** buf, enum rmapFusionType *x, int nDim, int *dims );
int scan_buf_enum_rmapBoolean (char** buf, enum rmapBoolean *x, int nDim, int *dims );
int scan_buf_struct_rmapLightMap (char** buf, struct rmapLightMap *x, int nDim, int *dims );
int scan_buf_struct_rmapMap (char** buf, struct rmapMap *x, int nDim, int *dims );
int scan_buf_struct_rmapCell (char** buf, struct rmapCell *x, int nDim, int *dims );
int scan_buf_enum_RMAP_PROBAS (char** buf, enum RMAP_PROBAS *x, int nDim, int *dims );
int scan_buf_enum_RMAP_CELL_STATUS (char** buf, enum RMAP_CELL_STATUS *x, int nDim, int *dims );

/* ======================== SCAN DES TYPEDEF ============================= */

int scan_buf_RMAP_CELL_STATUS (char** buf, RMAP_CELL_STATUS *x, int nDim, int *dims );
int scan_buf_RMAP_PROBAS (char** buf, RMAP_PROBAS *x, int nDim, int *dims );
int scan_buf_rmapCell (char** buf, rmapCell *x, int nDim, int *dims );
int scan_buf_rmapMap (char** buf, rmapMap *x, int nDim, int *dims );
int scan_buf_rmapLightMap (char** buf, rmapLightMap *x, int nDim, int *dims );
int scan_buf_rmapBoolean (char** buf, rmapBoolean *x, int nDim, int *dims );
int scan_buf_rmapFusionType (char** buf, rmapFusionType *x, int nDim, int *dims );
int scan_buf_rmapInitParams (char** buf, rmapInitParams *x, int nDim, int *dims );
int scan_buf_rmapConnection (char** buf, rmapConnection *x, int nDim, int *dims );
int scan_buf_rmapConnectionParams (char** buf, rmapConnectionParams *x, int nDim, int *dims );
int scan_buf_rmapCircleParams (char** buf, rmapCircleParams *x, int nDim, int *dims );
int scan_buf_rmapRadiusParams (char** buf, rmapRadiusParams *x, int nDim, int *dims );
int scan_buf_rmapLoadParams (char** buf, rmapLoadParams *x, int nDim, int *dims );
int scan_buf_rmapLoadPgmParams (char** buf, rmapLoadPgmParams *x, int nDim, int *dims );
int scan_buf_rmapSaveParams (char** buf, rmapSaveParams *x, int nDim, int *dims );
int scan_buf_rmapDisplayParams (char** buf, rmapDisplayParams *x, int nDim, int *dims );
int scan_buf_REGIONMAP_STR (char** buf, REGIONMAP_STR *x, int nDim, int *dims );
int scan_buf_REGIONMAP_LIGHTRMAP_POSTER_STR (char** buf, REGIONMAP_LIGHTRMAP_POSTER_STR *x, int nDim, int *dims );
#ifdef __cplusplus
}
#endif

#endif /* REGIONMAP_SCAN_H */

