
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] regionMapInstall] >= 0 } {
    interp expose {} regionMapInstall
}

proc ::regionMapInstall { name } {
    foreach rqst { "Init" "Connect" "LoadMap" "LoadPgmMap" "LoadRessacMap" "SetSaveParams" "GetSaveParams" "Save" "PrintMapInfos" "SetCircularArea" "SetLocalCircularArea" "UpdateMap" "UpdateLightPoster" "SavePoster" "InitDisplay" "StopDisplay" "UpdateDisplay" "GetDisplayParams" "LightRmapexportedLightPosterPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} regionMap$rqst $name
    }
}

interp hide {} regionMapInstall




# Init ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapInit] >= 0 } {
    interp expose {} regionMapInit
}
if { [lsearch [interp hidden] regionMapInitFormatOutput] >= 0 } {
    interp expose {} regionMapInitFormatOutput
}

proc ::regionMapInit { name args } {
    set format {}
    lappend format [list double "Scale" 1.000000 ]
    lappend format [list int "Size along X axis (in pixels)" 400 ]
    lappend format [list int "Size along Y axis (in pixels)" 400 ]
    lappend format [list double "x position of the map origin (in meters)" -10.000000 ]
    lappend format [list double "y position of the map origin (in meters)" -10.000000 ]
    lappend format [list double "Robot radius" 1.000000 ]
    lappend format [list { "RMAP_MERGE" "RMAP_OVERRIDE" } "Type of fusion" "RMAP_OVERRIDE" ]
    lappend format [list int "Prototypes fileName" "/tmp/velodynePrototypes.psp" ]
    lappend format [list string "Pom position poster name" "pomPos" ]
    lappend format [list string "initParams.pomPosPoster" "" ]

    return [ ::cs::rqstSend "${name}" "Init" \
	"Create the internal regionMap structure" \
	"rmapInitParams\n| double scale\n| int nbX\n| int nbY\n| double xOrigin\n| double yOrigin\n| double robotRadius\n| rmapFusionType fusionType\n| int padding\n| char protosFileName\[1024\]\n| char pomPosPoster\[1024\]\n" \
	10 \
	$format \
	$args ]
}


proc ::regionMapInitFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapInit
interp hide {} regionMapInitFormatOutput





# Connect ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapConnect] >= 0 } {
    interp expose {} regionMapConnect
}
if { [lsearch [interp hidden] regionMapConnectFormatOutput] >= 0 } {
    interp expose {} regionMapConnectFormatOutput
}

proc ::regionMapConnect { name args } {
    set format {}
    lappend format [list { "RMAP_VELODYNE_CONNECTION" "RMAP_STEREOPIXEL_CONNECTION" "RMAP_NO_CONNECTION" } "Module to connect to" "RMAP_STEREOPIXEL_CONNECTION" ]
    lappend format [list string "stereopixel poster name" "stereopixelThreeDImage" ]
    lappend format [list string "velodyne poster name" "velodyneThreeDImage" ]
    lappend format [list double "Max distance to consider points" "" ]

    return [ ::cs::rqstSend "${name}" "Connect" \
	"Connects to a module that produces 3D data" \
	"rmapConnectionParams\n| rmapConnection connection\n| char stereopixelPoster\[1024\]\n| char velodynePoster\[1024\]\n| double threshold\n" \
	4 \
	$format \
	$args ]
}


proc ::regionMapConnectFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapConnect
interp hide {} regionMapConnectFormatOutput





# LoadMap ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapLoadMap] >= 0 } {
    interp expose {} regionMapLoadMap
}
if { [lsearch [interp hidden] regionMapLoadMapFormatOutput] >= 0 } {
    interp expose {} regionMapLoadMapFormatOutput
}

proc ::regionMapLoadMap { name args } {
    set format {}
    lappend format [list string "File name" "/tmp/rmap" ]

    return [ ::cs::rqstSend "${name}" "LoadMap" \
	"Loads an existing map" \
	"rmapLoadParams\n| char fileName\[1024\]\n" \
	1 \
	$format \
	$args ]
}


proc ::regionMapLoadMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapLoadMap
interp hide {} regionMapLoadMapFormatOutput





# LoadPgmMap ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapLoadPgmMap] >= 0 } {
    interp expose {} regionMapLoadPgmMap
}
if { [lsearch [interp hidden] regionMapLoadPgmMapFormatOutput] >= 0 } {
    interp expose {} regionMapLoadPgmMapFormatOutput
}

proc ::regionMapLoadPgmMap { name args } {
    set format {}
    lappend format [list string "File name" "/tmp/rmap" ]
    lappend format [list double "Scale" 1.000000 ]
    lappend format [list double "x position of the map origin (in meters)" -10.000000 ]
    lappend format [list double "y position of the map origin (in meters)" -10.000000 ]
    lappend format [list double "Robot radius" 1.000000 ]

    return [ ::cs::rqstSend "${name}" "LoadPgmMap" \
	"Loads an existing map from a PGM file" \
	"rmapLoadPgmParams\n| char fileName\[1024\]\n| double scale\n| double xOrigin\n| double yOrigin\n| double robotRadius\n" \
	5 \
	$format \
	$args ]
}


proc ::regionMapLoadPgmMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapLoadPgmMap
interp hide {} regionMapLoadPgmMapFormatOutput





# LoadRessacMap ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapLoadRessacMap] >= 0 } {
    interp expose {} regionMapLoadRessacMap
}
if { [lsearch [interp hidden] regionMapLoadRessacMapFormatOutput] >= 0 } {
    interp expose {} regionMapLoadRessacMapFormatOutput
}

proc ::regionMapLoadRessacMap { name args } {
    set format {}
    lappend format [list string "File name" "/tmp/rmap" ]

    return [ ::cs::rqstSend "${name}" "LoadRessacMap" \
	"Loads an existing map built by Ressac" \
	"rmapLoadParams\n| char fileName\[1024\]\n" \
	1 \
	$format \
	$args ]
}


proc ::regionMapLoadRessacMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapLoadRessacMap
interp hide {} regionMapLoadRessacMapFormatOutput





# SetSaveParams ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapSetSaveParams] >= 0 } {
    interp expose {} regionMapSetSaveParams
}
if { [lsearch [interp hidden] regionMapSetSaveParamsFormatOutput] >= 0 } {
    interp expose {} regionMapSetSaveParamsFormatOutput
}

proc ::regionMapSetSaveParams { name args } {
    set format {}
    lappend format [list string "File name" "/tmp/rmap" ]
    lappend format [list int "num of the extension" 0 ]

    return [ ::cs::rqstSend "${name}" "SetSaveParams" \
	"Set the file name to save maps" \
	"rmapSaveParams\n| char fileName\[1024\]\n| int number\n" \
	2 \
	$format \
	$args ]
}


proc ::regionMapSetSaveParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapSetSaveParams
interp hide {} regionMapSetSaveParamsFormatOutput





# GetSaveParams ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapGetSaveParams] >= 0 } {
    interp expose {} regionMapGetSaveParams
}
if { [lsearch [interp hidden] regionMapGetSaveParamsFormatOutput] >= 0 } {
    interp expose {} regionMapGetSaveParamsFormatOutput
}

proc ::regionMapGetSaveParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetSaveParams" \
	"Shows the file name to save maps" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::regionMapGetSaveParamsFormatOutput { list } {
    set format { {} status { } { saveParams { } fileName { } number } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapGetSaveParams
interp hide {} regionMapGetSaveParamsFormatOutput





# Save ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapSave] >= 0 } {
    interp expose {} regionMapSave
}
if { [lsearch [interp hidden] regionMapSaveFormatOutput] >= 0 } {
    interp expose {} regionMapSaveFormatOutput
}

proc ::regionMapSave { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Save" \
	"Saves the current internal map in a file" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::regionMapSaveFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapSave
interp hide {} regionMapSaveFormatOutput





# PrintMapInfos ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapPrintMapInfos] >= 0 } {
    interp expose {} regionMapPrintMapInfos
}
if { [lsearch [interp hidden] regionMapPrintMapInfosFormatOutput] >= 0 } {
    interp expose {} regionMapPrintMapInfosFormatOutput
}

proc ::regionMapPrintMapInfos { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "PrintMapInfos" \
	"Prints info on the current internal map" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::regionMapPrintMapInfosFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapPrintMapInfos
interp hide {} regionMapPrintMapInfosFormatOutput





# SetCircularArea ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapSetCircularArea] >= 0 } {
    interp expose {} regionMapSetCircularArea
}
if { [lsearch [interp hidden] regionMapSetCircularAreaFormatOutput] >= 0 } {
    interp expose {} regionMapSetCircularAreaFormatOutput
}

proc ::regionMapSetCircularArea { name args } {
    set format {}
    lappend format [list double "X center coordinate (meters)" 0.000000 ]
    lappend format [list double "Y center coordinate (meters)" 0.000000 ]
    lappend format [list double "circle radius (meters, > 0)" 1.000000 ]
    lappend format [list double "obstacle probability (>= 0.0 and <= 1.0)" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "SetCircularArea" \
	"Sets a circular area at a given probability" \
	"rmapCircleParams\n| double xCenter\n| double yCenter\n| double radius\n| double probaObstacle\n" \
	4 \
	$format \
	$args ]
}


proc ::regionMapSetCircularAreaFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapSetCircularArea
interp hide {} regionMapSetCircularAreaFormatOutput





# SetLocalCircularArea ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapSetLocalCircularArea] >= 0 } {
    interp expose {} regionMapSetLocalCircularArea
}
if { [lsearch [interp hidden] regionMapSetLocalCircularAreaFormatOutput] >= 0 } {
    interp expose {} regionMapSetLocalCircularAreaFormatOutput
}

proc ::regionMapSetLocalCircularArea { name args } {
    set format {}
    lappend format [list double "circle radius (meters)" 1.000000 ]
    lappend format [list double "obstacle probability (>= 0.0 and <= 1.0)" 0.000000 ]

    return [ ::cs::rqstSend "${name}" "SetLocalCircularArea" \
	"Sets a circular area at a given probability centered at the current robot position" \
	"rmapRadiusParams\n| double radius\n| double probaObstacle\n" \
	2 \
	$format \
	$args ]
}


proc ::regionMapSetLocalCircularAreaFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapSetLocalCircularArea
interp hide {} regionMapSetLocalCircularAreaFormatOutput





# UpdateMap ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapUpdateMap] >= 0 } {
    interp expose {} regionMapUpdateMap
}
if { [lsearch [interp hidden] regionMapUpdateMapFormatOutput] >= 0 } {
    interp expose {} regionMapUpdateMapFormatOutput
}

proc ::regionMapUpdateMap { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "UpdateMap" \
	"Updates a map from 3D data" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::regionMapUpdateMapFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapUpdateMap
interp hide {} regionMapUpdateMapFormatOutput





# UpdateLightPoster ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapUpdateLightPoster] >= 0 } {
    interp expose {} regionMapUpdateLightPoster
}
if { [lsearch [interp hidden] regionMapUpdateLightPosterFormatOutput] >= 0 } {
    interp expose {} regionMapUpdateLightPosterFormatOutput
}

proc ::regionMapUpdateLightPoster { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "UpdateLightPoster" \
	"Updates the light poster from the internal map structure" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::regionMapUpdateLightPosterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapUpdateLightPoster
interp hide {} regionMapUpdateLightPosterFormatOutput





# SavePoster ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapSavePoster] >= 0 } {
    interp expose {} regionMapSavePoster
}
if { [lsearch [interp hidden] regionMapSavePosterFormatOutput] >= 0 } {
    interp expose {} regionMapSavePosterFormatOutput
}

proc ::regionMapSavePoster { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "SavePoster" \
	"Saves the poster as a PGM image" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::regionMapSavePosterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapSavePoster
interp hide {} regionMapSavePosterFormatOutput





# InitDisplay ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapInitDisplay] >= 0 } {
    interp expose {} regionMapInitDisplay
}
if { [lsearch [interp hidden] regionMapInitDisplayFormatOutput] >= 0 } {
    interp expose {} regionMapInitDisplayFormatOutput
}

proc ::regionMapInitDisplay { name args } {
    set format {}
    lappend format [list string "Gdhe server name" "localhost" ]
    lappend format [list string "File used for display (full unix path)" "/tmp/tmpGdheMap" ]
    lappend format [list int "Suffix number of the file used for display" 0 ]
    lappend format [list { "RMAP_TRUE" "RMAP_FALSE" } "Display merged probas ?" "RMAP_TRUE" ]
    lappend format [list { "RMAP_TRUE" "RMAP_FALSE" } "Display growed probas ?" "RMAP_TRUE" ]

    return [ ::cs::rqstSend "${name}" "InitDisplay" \
	"Initializes a display" \
	"rmapDisplayParams\n| char serverName\[1024\]\n| char fileName\[1024\]\n| int fileNumber\n| rmapBoolean mergedProbas\n| rmapBoolean growedProbas\n" \
	5 \
	$format \
	$args ]
}


proc ::regionMapInitDisplayFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapInitDisplay
interp hide {} regionMapInitDisplayFormatOutput





# StopDisplay ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapStopDisplay] >= 0 } {
    interp expose {} regionMapStopDisplay
}
if { [lsearch [interp hidden] regionMapStopDisplayFormatOutput] >= 0 } {
    interp expose {} regionMapStopDisplayFormatOutput
}

proc ::regionMapStopDisplay { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopDisplay" \
	"Disconnect from gdhe" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::regionMapStopDisplayFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapStopDisplay
interp hide {} regionMapStopDisplayFormatOutput





# UpdateDisplay ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapUpdateDisplay] >= 0 } {
    interp expose {} regionMapUpdateDisplay
}
if { [lsearch [interp hidden] regionMapUpdateDisplayFormatOutput] >= 0 } {
    interp expose {} regionMapUpdateDisplayFormatOutput
}

proc ::regionMapUpdateDisplay { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "UpdateDisplay" \
	"Updates a display" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::regionMapUpdateDisplayFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapUpdateDisplay
interp hide {} regionMapUpdateDisplayFormatOutput





# GetDisplayParams ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapGetDisplayParams] >= 0 } {
    interp expose {} regionMapGetDisplayParams
}
if { [lsearch [interp hidden] regionMapGetDisplayParamsFormatOutput] >= 0 } {
    interp expose {} regionMapGetDisplayParamsFormatOutput
}

proc ::regionMapGetDisplayParams { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetDisplayParams" \
	"Prints the display params" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::regionMapGetDisplayParamsFormatOutput { list } {
    set format { {} status { } { displayParams { } serverName { } fileName { } fileNumber { } mergedProbas { } growedProbas } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapGetDisplayParams
interp hide {} regionMapGetDisplayParamsFormatOutput





# LightRmapexportedLightPoster ----------------------------------------------------------

if { [lsearch [interp hidden] regionMapLightRmapexportedLightPosterPosterRead] >= 0 } {
    interp expose {} regionMapLightRmapexportedLightPosterPosterRead
}
if { [lsearch [interp hidden] regionMapLightRmapexportedLightPosterPosterFormatOutput] >= 0 } {
    interp expose {} regionMapLightRmapexportedLightPosterPosterFormatOutput
}

proc ::regionMapLightRmapexportedLightPosterPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "LightRmapexportedLightPoster" \
	"rmapLightMap\n| double scale\n| int xNb\n| int yNb\n| double xOrigin\n| double yOrigin\n| unsigned char probaObstacle\[1000000\]\n" \
	$args ]
}


proc ::regionMapLightRmapexportedLightPosterPosterFormatOutput { list } {
    set format { {} status { } { exportedLightPoster { } scale { } xNb { } yNb { } xOrigin { } yOrigin { 1000000 } probaObstacle } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} regionMapLightRmapexportedLightPosterPosterRead
interp hide {} regionMapLightRmapexportedLightPosterPosterFormatOutput


